<template>
	<v-card elevation="20">
		<v-card-title>Datos del domicilio</v-card-title>
		<v-form>
			<v-card-text>
				<v-row>
					<v-col cols="12" sm="3">
						<v-select
							:disabled="update"
							v-model="addressData.state"
							prepend-icon="fas fa-flag"
							outlined
							:rules="ruleRequired"
							:items="states"
							label="Estado"
							required
						/>
					</v-col>
					<v-col cols="12" sm="3">
						<v-select
							:disabled="update"
							v-model="addressData.city"
							no-data-text="Seleccione antes un estado"
							prepend-icon="fas fa-flag"
							outlined
							:rules="ruleRequired"
							:items="cities"
							label="Municipio"
							required
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-text-field
							:disabled="update"
							v-model="addressData.neighborhood"
							prepend-icon="fas fa-flag"
							outlined
							:rules="ruleRequired"
							label="Colonia"
							required
						/>
					</v-col>
				</v-row>
				<!-- fila de direccion -->
				<v-row>
					<v-col cols="12" sm="5">
						<v-text-field
							:disabled="update"
							v-model="addressData.street"
							prepend-icon="fas fa-road"
							outlined
							:rules="ruleRequired"
							label="Calle"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<v-text-field
							:disabled="update"
							v-model="addressData.number"
							prepend-icon="fas fa-home"
							outlined
							:rules="ruleRequired"
							label="Número"
							required
						/>
					</v-col>
					<v-col cols="12" sm="3">
						<v-text-field
							:disabled="update"
							type="number"
							min="0"
							prepend-icon="fas fa-envelope-open"
							outlined
							:rules="rulesCP"
							v-model="addressData.postalCode"
							label="Código postal"
							required
						/>
					</v-col>
				</v-row>
				<!-- fila de numeros telefónicos -->
				<v-row>
					<v-col cols="12" sm="4">
						<v-text-field
							:disabled="update"
							type="number"
							v-model="addressData.mobilePhoneNumber"
							prepend-icon="fas fa-mobile-alt"
							outlined
							:rules="rulesPhones"
							min="0"
							label="Teléfono celular"
							required
						/>
					</v-col>
					<v-col cols="12" sm="4">
						<p slot="label" class="headline">¿Tienes teléfono fijo?</p>
						<v-radio-group
							:disabled="update"
							row
							v-model="haveNumberPhone"
							mandatory
							prepend-icon="fas fa-phone-slash"
							required
						>
							<v-radio label="No" value="No" color="blue" />
							<v-radio label="Si" value="Si" color="blue" />
						</v-radio-group>
					</v-col>
					<v-col cols="12" sm="4" v-if="numberPhone">
						<v-text-field
							:disabled="update"
							type="number"
							v-model="addressData.housePhoneNumber"
							prepend-icon="fas fa-phone"
							outlined
							:rules="rulesPhones"
							min="0"
							label="Teléfono de casa"
							required
						/>
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify="center" justify-sm="end">
					<v-col cols="12" sm="3" v-if="update">
						<v-btn block outlined color="orange" @click="update = !update">Modificar</v-btn>
					</v-col>
					<v-col cols="12" sm="3" v-else>
						<v-btn block outlined color="red" @click="cancelUpdate">Cancelar</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn :disabled="update" block outlined :loading="loading" color="green" @click="updateData">
							Actualizar
							<template v-slot:loader>
								<span>Guardando...</span>
							</template>
						</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-form>
	</v-card>
</template>

<script>
import gql from "graphql-tag";
import { mapState, mapMutations } from "vuex";

export default {
	name: "ProfileAddressData",
	data: () => ({
		update: true,
		loading: false,
		haveNumberPhone: "No",
		addressData: {
			state: "",
			city: "",
			neighborhood: "",
			street: "",
			number: "",
			postalCode: "",
			housePhoneNumber: "",
			mobilePhoneNumber: ""
		},
		states: [],
		cities: [],
		ruleRequired: [value => !!value || "Campo requerido"],
		rulesCP: [
			value => !!value || "Campo requerido",
			value => (value || "").length === 5 || "5 números obligatorios"
		],
		rulesPhones: [
			value => !!value || "Campo requerido",
			value => (value || "").length === 10 || "10 números obligatorios"
		]
	}),
	computed: {
		...mapState(["userData"]),
		// condiciona si tiene numero fijo o no
		numberPhone() {
			return this.haveNumberPhone === "No" ? false : true;
		}
	},
	watch: {
		// Escucha el input del estado para consultar los municipios
		"addressData.state": function(newValue, oldValue) {
			this.getCities();
		}
	},
	methods: {
		...mapMutations(["saveUserData"]),

		// Obtiene los estados
		async getStates() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query {
							allStates
						}
					`
				});
				this.states = data.allStates;
			} catch (error) {}
		},

		// Obtiene los municipios del estado seleccionado
		async getCities() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($state: String!) {
							allCities(state: $state)
						}
					`,
					variables: {
						state: this.addressData.state
					}
				});
				this.cities = data.allCities;
			} catch (error) {}
		},

		// Obtiene los datos del usuario para llenar los inputs
		async getData() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								addressData {
									state
									city
									neighborhood
									street
									number
									postalCode
									mobilePhoneNumber
									housePhoneNumber
								}
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				this.addressData.state = data.findStudent.addressData.state;
				this.addressData.city = data.findStudent.addressData.city;
				this.addressData.neighborhood =
					data.findStudent.addressData.neighborhood;
				this.addressData.street = data.findStudent.addressData.street;
				this.addressData.number = data.findStudent.addressData.number;
				this.addressData.postalCode =
					data.findStudent.addressData.postalCode;
				this.addressData.mobilePhoneNumber =
					data.findStudent.addressData.mobilePhoneNumber;
				this.addressData.housePhoneNumber =
					data.findStudent.addressData.housePhoneNumber;
				this.addressData.housePhoneNumber !== ""
					? (this.haveNumberPhone = "Si")
					: (this.haveNumberPhone = "No");
			} catch (error) {}
		},
		// cancela la modificacion de los inputs
		cancelUpdate() {
			this.getData();
			this.update = !this.update;
		},
		// Actualiza los campos
		async updateData() {
			if (this.haveNumberPhone === "No") {
				this.addressData.housePhoneNumber = "";
			}
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$state: String!
							$city: String!
							$neighborhood: String!
							$street: String!
							$number: String!
							$postalCode: String!
							$mobilePhoneNumber: String!
							$housePhoneNumber: String!
						) {
							addUpdateAddressData(
								state: $state
								city: $city
								neighborhood: $neighborhood
								street: $street
								number: $number
								postalCode: $postalCode
								mobilePhoneNumber: $mobilePhoneNumber
								housePhoneNumber: $housePhoneNumber
							)
						}
					`,
					variables: {
						state: this.addressData.state,
						city: this.addressData.city,
						neighborhood: this.addressData.neighborhood,
						street: this.addressData.street,
						number: this.addressData.number,
						postalCode: this.addressData.postalCode,
						mobilePhoneNumber: this.addressData.mobilePhoneNumber,
						housePhoneNumber: this.addressData.housePhoneNumber
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.update = true;
				}, 1500);
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.getData();
		this.getStates();
	}
};
</script>